﻿using System;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;
using egami.Properties;

namespace egami
{
    public partial class MainForm : Form
    {
        private int _childFormNumber;

        public MainForm()
        {
            InitializeComponent();
        }

        private void ShowNewForm(object sender, EventArgs e)
        {
            var childForm = new ImageForm
            {
                MdiParent = this,
                Text = "Window " + _childFormNumber++
            };
            childForm.Show();
        }

        private void OpenFile(object sender, EventArgs e)
        {
            var openFileDialog = new OpenFileDialog
            {
                InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Personal),
                Filter = Resources.SupportedFileTypesFilter
            };
            if (openFileDialog.ShowDialog(this) != DialogResult.OK) return;
            var fileName = openFileDialog.FileName;

            var childForm = new ImageForm
            {
                MdiParent = this,
                Text = fileName,
                pictureBox = {ImageLocation = fileName}
            };
            childForm.Show();
        }

        private void SaveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            var saveFileDialog = new SaveFileDialog();
            saveFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            saveFileDialog.Filter = "Text Files (*.txt)|*.txt|All Files (*.*)|*.*";
            if (saveFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                var FileName = saveFileDialog.FileName;
            }
        }

        private void ExitToolsStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void CutToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void CopyToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void PasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void ToolBarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            toolStrip.Visible = toolBarToolStripMenuItem.Checked;
        }

        private void StatusBarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            statusStrip.Visible = statusBarToolStripMenuItem.Checked;
        }

        private void CascadeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.Cascade);
        }

        private void TileVerticalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileVertical);
        }

        private void TileHorizontalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileHorizontal);
        }

        private void ArrangeIconsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.ArrangeIcons);
        }

        private void CloseAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (var childForm in MdiChildren)
                childForm.Close();
        }

        private void resizeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            var resizeForm = new ResizeForm {Tag = ((ImageForm) ActiveMdiChild)?.pictureBox.Image};
            if (resizeForm.ShowDialog() != DialogResult.OK) return;
            Debug.Assert(ActiveMdiChild != null, "ActiveMdiChild != null");
            ((ImageForm) ActiveMdiChild).pictureBox.Image = (Image) resizeForm.Tag;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
        }
    }
}